            #GIT_CMT=8d8c43a2a3ed32ca6cd0b4fe08a4eef3a94ac6f3
Name: al-config
Version: 1.0
Release:    3.el7
Summary: Configuration tasks for Autonomous Linux instances running in Oracle Cloud Infrastructure
BuildArch: noarch

Group: Development/Tools
URL: http://cloud.oracle.com/iaas
License: UPL
Vendor: Oracle America

Source: %{name}-%{version}.tar.gz

Requires: util-linux
Requires: uptrack
Requires: yum-cron
Requires: jq
Requires: rsyslog
Requires: openssl
Requires: python-oci-cli
Requires: python-oci-sdk
Requires: policycoreutils
Requires: selinux-policy
Buildrequires: checkpolicy policycoreutils-python

%description
This package contains configuration tasks for Autonomous Linux instances running in Oracle Cloud Infrastructure environment

%prep
%autosetup -p1

%build
### compile the selinux policy module
checkmodule -M -m -o omprog_exploit_detection.mod omprog_exploit_detection.te
semodule_package -o omprog_exploit_detection.pp -m omprog_exploit_detection.mod

%install
rm -rf %{buildroot}/*
cp -a install/*  %{buildroot}
install -d %{buildroot}%{_datadir}/selinux/packages
install -m 0644 omprog_exploit_detection.pp %{buildroot}%{_datadir}/selinux/packages

%files

#/usr/lib
%dir %{_prefix}/lib/%{name}
%attr(644,root,root) %{_prefix}/lib/%{name}/functions
%attr(755,root,root) %{_prefix}/lib/%{name}/pre_config.sh
%attr(755,root,root) %{_prefix}/lib/%{name}/add_cron_job.sh
%attr(755,root,root) %{_prefix}/lib/%{name}/activate_known_exploit_detection.sh
%attr(400,root,root) %{_prefix}/lib/%{name}/ksplice_access_key
%attr(644,root,root) %{_prefix}/lib/systemd/system/al-config.service
%attr(644,root,root) %{_prefix}/lib/systemd/system-preset/84-al.preset
#/usr/sbin
%attr(755,root,root) %{_sbindir}/al-config
%attr(755,root,root) %{_sbindir}/al-start
%attr(755,root,root) %{_sbindir}/al-update
%attr(755,root,root) %{_sbindir}/al-notify
%attr(755,root,root) %{_sbindir}/al-exploit-alert
#/usr/share
%attr(644,root,root) %{_datadir}/selinux/packages/omprog_exploit_detection.pp
#/etc
%attr(644,root,root) %config(noreplace) %{_sysconfdir}/%{name}/al.conf
%attr(644,root,root) %{_sysconfdir}/%{name}/yum-cron.conf
%attr(644,root,root) %{_sysconfdir}/logrotate.d/%{name}
%attr(644,root,root) %{_sysconfdir}/profile.d/al.sh
%attr(644,root,root) %{_sysconfdir}/rsyslog.d/al-exploit-alert.conf
#/var
%dir %{_sharedstatedir}/%{name}

%license LICENSE

%post
# install or upgrade
%{_prefix}/lib/%{name}/pre_config.sh
%{_sbindir}/semodule -i %{_datadir}/selinux/packages/omprog_exploit_detection.pp
%systemd_post %{name}.service
# restart rsyslog to enable exploit alert
/bin/systemctl try-restart rsyslog.service >/dev/null 2>&1 || :

%preun
# uninstall, not upgrade
if [ $1 -eq 0 ]; then
    rm -f %{_sysconfdir}/cron.d/al-update
    %{_sbindir}/semodule -r omprog_exploit_detection &>/dev/null
fi
%systemd_preun %{name}.service

%postun
%systemd_postun_with_restart %{name}.service

%posttrans

%changelog
* Mon Jan 27 2020 Frank Deng <frank.deng@oracle.com> - 1.0-3.el7
- Fix file /var/lib/yum/uuid permissions (Frank Deng)  [Orabug: 30809376] 
- Re-create al-update cron job when new system uuid is detected (Frank Deng)  [Orabug: 30641733] 
- Update AL only ksplice access key [Orabug: 30420716] (Frank Deng)  [Orabug: 30420716] 
- Display ksplice first in summary (Frank Deng)  

* Tue Sep 24 2019 Frank Deng <frank.deng@oracle.com> - 1.0-1.0.29.el7
- Fixes for ACL-67 - Send notification once topic OCID is configured. - Do not
  report 'needs-restaring' status be default. - Print welcome message for opc
  user login. - Fix exploit alert message. (Frank Deng)

* Fri Sep 13 2019 Frank Deng <frank.deng@oracle.com> - 1.0-1.0.28.el7
- Add license url (Frank Deng)  
- Add disclaimer (Frank Deng)

* Sat Sep 07 2019 Frank Deng <frank.deng@oracle.com> - 1.0-1.0.26.el7
- Fix for al-config for api key without passphrase (Frank Deng)  
- Always try to send notification if the notification didn't send last time Typo fixes (Frank Deng)  
- Log exploit attempt beforing sending notification (Frank Deng)

* Fri Sep 06 2019 Frank Deng <frank.deng@oracle.com> - 1.0-1.0.24.el7
- Fix topos in output messages (Frank Deng)

* Fri Sep 06 2019 Frank Deng <frank.deng@oracle.com> - 1.0-1.0.23.el7
- Try OCI CLI with instance principal auth if CLI config is not available (Frank
  Deng)

* Thu Sep 05 2019 Frank Deng <frank.deng@oracle.com> - 1.0-1.0.22.el7
- Allow to configure api key passphrase from url (Frank Deng)

* Thu Sep 05 2019 Frank Deng <frank.deng@oracle.com> - 1.0-1.0.21.el7
- Remove compartment parameter and move notification topic to oci.conf (Frank
  Deng)

* Thu Sep 05 2019 Frank Deng <frank.deng@oracle.com> - 1.0-1.0.20.el7
- Simplify email notification subject (Frank Deng)

* Wed Sep 04 2019 Frank Deng <frank.deng@oracle.com> - 1.0-1.0.19.el7
- Use uptrack commands if ksplice is not available (Frank Deng)

* Wed Sep 04 2019 Frank Deng <frank.deng@oracle.com> - 1.0-1.0.18.el7
- Reduce syslog_t allow access (Frank Deng)  
- Add selinux custom rule to support al-notify binary, being triggered by rsyslog (Alexander Burmashev)  
- Typo fix (Frank Deng)

* Tue Sep 03 2019 Frank Deng <frank.deng@oracle.com> - 1.0-1.0.17.el7
- Add systemd service and exploit alert script. - Add al-config.service to
  create cron job and activate exploit detection. - Add al-exploit-alert and
  rsyslog rule to trigger exploit alert (Frank Deng)

* Sun Sep 01 2019 Frank Deng <frank.deng@oracle.com> - 1.0-1.0.16.el7
- Fix build error due to typo (Frank Deng)  
- Use 'ksplice all upgrade' instead of 'uptrack-upgrade' and 'ksplice user upgrade' (Frank Deng)  
- Activate known exploit detection and report exploit attempts. (Frank Deng)

* Sun Sep 01 2019 Frank Deng <frank.deng@oracle.com> - 1.0-1.0.14.el7
- Improve logic to determine whether to send notification. (Frank Deng)

* Sat Aug 31 2019 Frank Deng <frank.deng@oracle.com> - 1.0-1.0.13.el7
- Beautified notification message content (Frank Deng)  
- Replace 'ksplice kernel upgrade' with 'uptrack-upgrade', better way to disable ksplice/yum-cron cron jobs. (Frank Deng)

* Fri Aug 30 2019 Frank Deng <frank.deng@oracle.com> - 1.0-1.0.12.el7
- add read_file() to support url (Frank Deng)

* Fri Aug 30 2019 Frank Deng <frank.deng@oracle.com> - 1.0-1.0.11.el7
- Add source files

* Fri Aug 30 2019 Frank Deng <frank.deng@oracle.com> - 1.0-1.0.10.el7
- Add source files

* Fri Aug 30 2019 Frank Deng <frank.deng@oracle.com> - 1.0-1.0.10
- Initial commit.

